local function GetClassColor(unit)
	local DB = TidyPlatesThreat.db.profile
	local c, class
	if unit.class and (unit.class ~= "") then
		class = unit.class
	elseif unit.guid then
		local _, class = GetPlayerInfoByGUID(unit.guid)
	end
	if class then
		c = RAID_CLASS_COLORS[class]
	end
	return c
end

local function SetNameColor(unit)
	local DB = TidyPlatesThreat.db.profile.settings.name
	local c

	if unit.unitid then
		local isFriend = UnitIsFriend("player", unit.unitid)
		if DB.colorFriendlyClass and isFriend then
			c = GetClassColor(unit)
			if not c then
				c = {r = 0, g = 1, b = 0}
			end
		end
		if DB.colorEnemyClass and not isFriend then
			c = GetClassColor(unit)
		end
	end

	if not c then
		c = DB.color
	end

	return c.r, c.g, c.b
end

TidyPlatesThreat.SetNameColor = SetNameColor
